--- old/usr/src/head/wctype.h	Sun Jun 29 11:51:27 2014
+++ new/usr/src/head/wctype.h	Sun Jun 29 11:51:27 2014
@@ -115,6 +115,7 @@
 extern	int iswideogram(wint_t);
 extern	int iswphonogram(wint_t);
 extern	int iswnumber(wint_t);
+extern	int iswhexnumber(wint_t);
 extern	int iswspecial(wint_t);
 
 #else	/* __STDC__ */
--- old/usr/src/lib/libc/port/locale/collate.c	Sun Jun 29 11:51:28 2014
+++ new/usr/src/lib/libc/port/locale/collate.c	Sun Jun 29 11:51:28 2014
@@ -62,7 +62,6 @@
 
 struct locdata __posix_collate_locdata = {
 	.l_lname = "C",
-	.l_refcnt = (uint32_t)-1,
 	.l_data = { &lc_collate_posix }
 };
 
--- old/usr/src/lib/libc/port/locale/lmessages.c	Sun Jun 29 11:51:28 2014
+++ new/usr/src/lib/libc/port/locale/lmessages.c	Sun Jun 29 11:51:28 2014
@@ -48,7 +48,6 @@
 
 struct locdata __posix_messages_locdata = {
 	.l_lname = "C",
-	.l_refcnt = (uint32_t)-1,
 	.l_data = { &lc_messages_posix }
 };
 
@@ -68,7 +67,7 @@
 	    (const char **)lmsgs);
 
 	if (ret != _LDP_LOADED) {
-		__locdata_release(ldata);
+		__locdata_free(ldata);
 		errno = EINVAL;
 		return (NULL);
 	}
--- old/usr/src/lib/libc/port/locale/lmonetary.c	Sun Jun 29 11:51:29 2014
+++ new/usr/src/lib/libc/port/locale/lmonetary.c	Sun Jun 29 11:51:29 2014
@@ -73,7 +73,6 @@
 
 struct locdata __posix_monetary_locdata = {
 	.l_lname = "C",
-	.l_refcnt = (uint32_t)-1,
 	.l_data = { &lc_monetary_posix }
 };
 
@@ -105,7 +104,7 @@
 	    (const char **)lmon);
 
 	if (ret != _LDP_LOADED) {
-		__locdata_release(ldata);
+		__locdata_free(ldata);
 		errno = EINVAL;
 		return (NULL);
 	}
--- old/usr/src/lib/libc/port/locale/lnumeric.c	Sun Jun 29 11:51:29 2014
+++ new/usr/src/lib/libc/port/locale/lnumeric.c	Sun Jun 29 11:51:29 2014
@@ -47,14 +47,12 @@
 
 struct locdata __posix_numeric_locdata = {
 	.l_lname = "C",
-	.l_refcnt = (uint32_t)-1,
 	.l_data = { &lc_numeric_posix }
 };
 
 
 /*
- * Return the locale's numeric locdata structure, places a hold on it,
- * which the caller must release.
+ * Return the locale's numeric locdata structure.
  */
 struct locdata *
 __lc_numeric_load(const char *name)
@@ -73,7 +71,7 @@
 	    "LC_NUMERIC", LCNUMERIC_SIZE, LCNUMERIC_SIZE, (const char **)lnum);
 
 	if (ret != _LDP_LOADED) {
-		__locdata_release(ldata);
+		__locdata_free(ldata);
 		return (NULL);
 	}
 
--- old/usr/src/lib/libc/port/locale/localeimpl.c	Sun Jun 29 11:51:31 2014
+++ new/usr/src/lib/libc/port/locale/localeimpl.c	Sun Jun 29 11:51:31 2014
@@ -69,14 +69,17 @@
  * As a consequence of this, applications that iterate over all possible
  * locales will burn through a lot of virtual memory, but we find such
  * applications rare.  (locale -a might be an exception, but it is short lived.)
+ *
+ * Category data is never released (although enclosing locale objects might be),
+ * in order to guarantee thread-safety.  Calling freelocale() on an object
+ * while it is in use by another thread is a programmer error (use-after-free)
+ * and we don't bother to note it further.
+ *
+ * Locale objects (global locales) established by setlocale() are also
+ * never freed (for MT safety), but we will save previous locale objects
+ * and reuse them when we can.
  */
 
-/*
- * NB: Each of the structures listed herein should have the refcnt
- * set to -1, to ensure that posix locale information is never ever freed,
- * even when changing the global locale.
- */
-
 typedef struct locdata *(*loadfn_t)(const char *);
 
 static const loadfn_t loaders[LC_ALL] = {
@@ -143,35 +146,11 @@
 static const char *get_locale_env(int);
 static struct locdata *locdata_get(int, const const char *);
 static struct locdata *locdata_get_cache(int, const char *);
-static void locdata_set_cache(int, struct locdata *);
 
 /*
  * Some utility routines.
  */
-struct locdata *
-__locdata_hold(struct locdata *ld)
-{
-	if (ld != NULL && ld->l_refcnt != (uint32_t)-1)
-		atomic_inc_32(&ld->l_refcnt);
-	return (ld);
-}
 
-void
-__locdata_release(struct locdata *ld)
-{
-	if (ld->l_refcnt == (uint32_t)-1)
-		return;
-
-	if (atomic_dec_32_nv(&ld->l_refcnt) == 0) {
-		for (int i = 0; i < NLOCDATA; i++)
-			free(ld->l_data[i]);
-		if (ld->l_map && ld->l_map_len) {
-			(void) munmap(ld->l_map, ld->l_map_len);
-		}
-		free(ld);
-	}
-}
-
 struct locdata *
 __locdata_alloc(const char *name, size_t memsz)
 {
@@ -186,12 +165,25 @@
 		return (NULL);
 	}
 	(void) strlcpy(ldata->l_lname, name, sizeof (ldata->l_lname));
-	ldata->l_refcnt = 1;
 
 	return (ldata);
 }
 
 /*
+ * Normally we never free locale data truly, but if we failed to load it
+ * for some reason, this routine is used to cleanup the partial mess.
+ */
+void
+__locdata_free(struct locdata *ldata)
+{
+	for (int i = 0; i < NLOCDATA; i++)
+		free(ldata->l_data[i]);
+	if (ldata->l_map != NULL && ldata->l_map_len)
+		(void) munmap(ldata->l_map, ldata->l_map_len);
+	free(ldata);
+}
+
+/*
  * It turns out that for performance reasons we would really like to
  * cache the most recently referenced locale data to avoid wasteful
  * loading from files.
@@ -198,6 +190,7 @@
  */
 
 static struct locdata *cache_data[LC_ALL];
+static struct locdata *cat_data[LC_ALL];
 static mutex_t cache_lock = DEFAULTMUTEX;
 
 /*
@@ -214,40 +207,66 @@
 	if (category < 0 || category >= LC_ALL)
 		return (NULL);
 
+	/* Try cache first. */
 	lmutex_lock(&cache_lock);
-	if ((loc = cache_data[category]) != NULL) {
-		if (strcmp(locname, loc->l_lname) == 0) {
-			loc = __locdata_hold(loc);
-		} else {
-			loc = NULL;
-		}
+	loc = cache_data[category];
+
+	if ((loc != NULL) && (strcmp(loc->l_lname, locname) == 0)) {
+		lmutex_unlock(&cache_lock);
+		return (loc);
 	}
-	lmutex_unlock(&cache_lock);
-	return (loc);
-}
 
-/*
- * Set the cache for the category to specific content.  An additional hold
- * is taken for the data while it is in the cache, so the caller may drop
- * its own hold once this is complete.  Also, releases the hold on any
- * previously cached data.
- */
-static void
-locdata_set_cache(int category, struct locdata *loc)
-{
-	struct locdata *old;
+	/*
+	 * Failing that try previously loaded locales (linear search) --
+	 * this could be optimized to a hash, but its unlikely that a single
+	 * application will ever need to work with more than a few locales.
+	 */
+		for (loc = cat_data[category]; loc != NULL; loc = loc->l_next) {
+			if (strcmp(locname, loc->l_lname) == 0) {
+				break;
+			}
+		}
 
-	if (category < 0 || category >= LC_ALL)
-		return;
+		/*
+		 * Finally, if we still don't have one, try loading the locale
+		 * data from the actual on-disk data.
+		 *
+		 * We drop the lock (libc wants to ensure no internal locks
+		 * are held when we call other routines required to read from
+		 * files, allocate memory, etc.)  There is a small race here,
+		 * but the consequences of the race are benign -- if multiple
+		 * threads hit this at precisely the same point, we could
+		 * wind up with duplicates of the locale data in the cache.
+		 *
+		 * This wastes the memory for an extra copy of the locale
+		 * data, but there is no further harm beyond that.  Its not
+		 * worth the effort to recode this to something "safe"
+		 * (which would require rescanning the list, etc.), given
+		 * that this race will probably never actually occur.
+		 */
+		if (loc == NULL) {
+			lmutex_unlock(&cache_lock);
+			loc = (*loaders[category])(locname);
+			lmutex_lock(&cache_lock);
+			(void) strlcpy(loc->l_lname, locname,
+			    sizeof (loc->l_lname));
+		}
 
-	lmutex_lock(&cache_lock);
-	old = cache_data[category];
-	cache_data[category] = __locdata_hold(loc);
-	lmutex_unlock(&cache_lock);
+	/*
+	 * Assuming we got one, update the cache, and stick us on the list
+	 * of loaded locale data.  We insert into the head (more recent
+	 * use is likely to win.)
+	 */
+	if (loc != NULL) {
+		cache_data[category] = loc;
+		if (loc->l_next == NULL) {
+			loc->l_next = cat_data[category];
+			cat_data[category] = loc;
+		}
+	}
 
-	/* drop our reference on the old data */
-	if (old)
-		__locdata_release(old);
+	lmutex_unlock(&cache_lock);
+	return (loc);
 }
 
 /*
@@ -258,7 +277,6 @@
 static struct locdata *
 locdata_get(int category, const char *locname)
 {
-	struct locdata *ldata;
 	char scratch[ENCODING_LEN + 1];
 	char *slash;
 	int cnt;
@@ -290,18 +308,9 @@
 	}
 
 	if ((strcmp(locname, "C") == 0) || (strcmp(locname, "POSIX") == 0))
-		return (__locdata_hold(posix_locale.locdata[category]));
+		return (posix_locale.locdata[category]);
 
-	ldata = locdata_get_cache(category, locname);
-	if (ldata != NULL)
-		return (ldata);
-
-	/* Otherwise load it */
-	ldata = (*loaders[category])(locname);
-	if (ldata != NULL) {
-		locdata_set_cache(category, ldata);
-	}
-	return (ldata);
+	return (locdata_get_cache(category, locname));
 }
 
 /* tsd destructor */
@@ -368,8 +377,12 @@
 	if (loc == NULL) {
 		return (NULL);
 	}
+	if (src == NULL) {
+		/* illumos extension: POSIX says LC_GLOBAL_LOCALE here */
+		src = ___global_locale;
+	}
 	for (i = 0; i < LC_ALL; i++) {
-		loc->locdata[i] = __locdata_hold(src->locdata[i]);
+		loc->locdata[i] = src->locdata[i];
 		loc->loaded[i] = 0;
 	}
 	loc->collate = loc->locdata[LC_COLLATE]->l_data[0];
@@ -385,10 +398,12 @@
 void
 freelocale(locale_t loc)
 {
-	int i;
-	for (i = 0; i < LC_ALL; i++)
-		__locdata_release(loc->locdata[i]);
-	if (loc != &posix_locale)
+	/*
+	 * We take extra care never to free a saved locale created by
+	 * setlocale().  This shouldn't be strictly necessary, but a little
+	 * extra safety doesn't hurt here.
+	 */
+	if ((loc != &posix_locale) && (loc->next == NULL))
 		free(loc);
 }
 
@@ -402,7 +417,15 @@
 		errno = EINVAL;
 		return (NULL);
 	}
-	loc = duplocale(base != NULL ? base : ___global_locale);
+	/*
+	 * Technically passing LC_GLOBAL_LOCALE here is illegal,
+	 * but we allow it.
+	 */
+	if (base == NULL || base == ___global_locale) {
+		loc = duplocale(___global_locale);
+	} else {
+		loc = base;
+	}
 	if (loc == NULL) {
 		return (NULL);
 	}
@@ -421,12 +444,8 @@
 			errno = e;
 			return (NULL);
 		}
-		__locdata_release(loc->locdata[i]);
 		loc->locdata[i] = ldata;
 	}
-	if (base && base != ___global_locale) {
-		freelocale(base);
-	}
 	loc->collate = loc->locdata[LC_COLLATE]->l_data[0];
 	loc->ctype = loc->locdata[LC_CTYPE]->l_data[0];
 	loc->runelocale = loc->locdata[LC_CTYPE]->l_data[1];
--- old/usr/src/lib/libc/port/locale/localeimpl.h	Sun Jun 29 11:51:33 2014
+++ new/usr/src/lib/libc/port/locale/localeimpl.h	Sun Jun 29 11:51:33 2014
@@ -10,7 +10,7 @@
  */
 
 /*
- * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  */
 
 /*
@@ -50,12 +50,13 @@
 	void		*l_data[NLOCDATA];		/* storage area */
 	void		*l_map;				/* mapped file */
 	size_t		l_map_len;
-	uint32_t	l_refcnt;
+	struct locdata	*l_next;			/* link cached list */
 };
 
 
 struct locale {
 	struct locdata	*locdata[LC_ALL];
+	struct locale	*next;
 
 	/*
 	 * Convenience pointers.
@@ -81,8 +82,7 @@
 
 
 struct locdata *__locdata_alloc(const char *, size_t);
-struct locdata *__locdata_hold(struct locdata *);
-void __locdata_release(struct locdata *);
+void __locdata_free(struct locdata *);
 struct locdata *__locdata_get_cache(int, const char *);
 void __locdata_set_cache(int, struct locdata *);
 
--- old/usr/src/lib/libc/port/locale/mblen.c	Sun Jun 29 11:51:36 2014
+++ new/usr/src/lib/libc/port/locale/mblen.c	Sun Jun 29 11:51:36 2014
@@ -1,5 +1,5 @@
 /*
- * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -37,13 +37,11 @@
 int
 mblen_l(const char *s, size_t n, locale_t loc)
 {
-	static const mbstate_t initial = { 0 };
-	static mbstate_t mbs;
+	mbstate_t mbs = { 0 };
 	size_t rval;
 
 	if (s == NULL) {
 		/* No support for state dependent encodings. */
-		mbs = initial;
 		return (0);
 	}
 	rval = mbrtowc_l(NULL, s, n, &mbs, loc);
--- old/usr/src/lib/libc/port/locale/mbtowc.c	Sun Jun 29 11:51:39 2014
+++ new/usr/src/lib/libc/port/locale/mbtowc.c	Sun Jun 29 11:51:39 2014
@@ -1,5 +1,5 @@
 /*
- * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -37,13 +37,11 @@
 mbtowc_l(wchar_t *_RESTRICT_KYWD pwc, const char *_RESTRICT_KYWD s, size_t n,
     locale_t loc)
 {
-	static const mbstate_t initial = { 0 };
-	static mbstate_t mbs;
+	mbstate_t mbs = { 0 };
 	size_t rval;
 
 	if (s == NULL) {
 		/* No support for state dependent encodings. */
-		mbs = initial;
 		return (0);
 	}
 	rval = mbrtowc_l(pwc, s, n, &mbs, loc);
--- old/usr/src/lib/libc/port/locale/setlocale.c	Sun Jun 29 11:51:42 2014
+++ new/usr/src/lib/libc/port/locale/setlocale.c	Sun Jun 29 11:51:42 2014
@@ -43,6 +43,7 @@
 #include <string.h>
 #include <unistd.h>
 #include <stdio.h>
+#include "mtlib.h"
 #include "collate.h"
 #include "lnumeric.h"	/* for struct lc_numeric */
 #include "lctype.h"	/* for struct lc_ctype */
@@ -59,11 +60,14 @@
 static char	*current_locale(locale_t, int);
 static void	install_legacy(locale_t, int);
 
+static mutex_t setlocale_lock = DEFAULTMUTEX;
+static locale_t setlocale_list = NULL;
+
 char *
 setlocale(int category, const char *locname)
 {
-	locale_t oldloc;
-	locale_t newloc;
+	locale_t loc;
+	locale_t srch;
 	int mask;
 
 	if (category < 0 || category > LC_ALL) {
@@ -74,24 +78,46 @@
 	if (locname == NULL)
 		return (current_locale(___global_locale, category));
 
-	if ((oldloc = duplocale(___global_locale)) == NULL)
-		return (NULL);
-
 	mask = (category == LC_ALL ? LC_ALL_MASK : (1 << category));
 
-	newloc = newlocale(mask, locname, oldloc);
-	if (newloc == NULL) {
-		freelocale(oldloc);
+	loc = newlocale(mask, locname, NULL);
+	if (loc == NULL) {
 		return (NULL);
 	}
 
-	oldloc = ___global_locale;
-	___global_locale = newloc;
+	/*
+	 * This next logic looks to see if we have ever used the same locale
+	 * settings before.  If so, we reuse it.  We avoid ever calling
+	 * freelocale() on a locale setting built up by setlocale, this
+	 * ensures that consumers (uselocale) will always be thread safe;
+	 * the actual locale data objects are never freed, and unique
+	 * locale objects are also never freed.  We reuse to avoid leaking
+	 * memory in applications that call setlocale repeatedly.
+	 */
+	lmutex_lock(&setlocale_lock);
+	for (srch = setlocale_list; srch != NULL; srch = srch->next) {
+		if (memcmp(srch->locdata, loc->locdata,
+		    sizeof (loc->locdata[0]) * LC_ALL) != 0) {
+			continue;
+		}
+		break;
+	}
 
-	install_legacy(newloc, mask);
+	if (srch == NULL) {
+		/* this is a new locale, save it for reuse later */
+		loc->next = setlocale_list;
+		setlocale_list = loc;
+	} else {
+		/* we already had it, toss the new, and use what we found */
+		freelocale(loc);
+		loc = srch;
+	}
+	___global_locale = loc;
 
-	freelocale(oldloc);
-	return (current_locale(newloc, category));
+	install_legacy(loc, mask);
+	lmutex_unlock(&setlocale_lock);
+
+	return (current_locale(loc, category));
 }
 
 static char *
--- old/usr/src/lib/libc/port/locale/setrunelocale.c	Sun Jun 29 11:51:44 2014
+++ new/usr/src/lib/libc/port/locale/setrunelocale.c	Sun Jun 29 11:51:44 2014
@@ -66,7 +66,6 @@
 
 struct locdata __posix_ctype_locdata = {
 	.l_lname = "C",
-	.l_refcnt = (uint32_t)-1,
 	.l_data = { &lc_ctype_posix, &_DefaultRuneLocale }
 };
 
@@ -114,7 +113,7 @@
 	    _PathLocale, name);
 
 	if ((rl = _Read_RuneMagi(path)) == NULL) {
-		__locdata_release(ldata);
+		__locdata_free(ldata);
 		errno = EINVAL;
 		return (NULL);
 	}
@@ -139,7 +138,7 @@
 		}
 	}
 	if (encodings[i].e_name == NULL) {
-		__locdata_release(ldata);
+		__locdata_free(ldata);
 		errno = EINVAL;
 		return (NULL);
 	}
--- old/usr/src/lib/libc/port/locale/timelocal.c	Sun Jun 29 11:51:47 2014
+++ new/usr/src/lib/libc/port/locale/timelocal.c	Sun Jun 29 11:51:47 2014
@@ -85,7 +85,6 @@
 
 struct locdata __posix_time_locdata = {
 	.l_lname = "C",
-	.l_refcnt = (uint32_t)-1,
 	.l_data = { &lc_time_posix }
 };
 
@@ -106,7 +105,7 @@
 	    "LC_TIME", LCTIME_SIZE, LCTIME_SIZE, (const char **)ltime);
 
 	if (ret != _LDP_LOADED) {
-		__locdata_release(ldata);
+		__locdata_free(ldata);
 		errno = EINVAL;
 		return (NULL);
 	}
--- old/usr/src/lib/libc/port/locale/wctomb.c	Sun Jun 29 11:51:49 2014
+++ new/usr/src/lib/libc/port/locale/wctomb.c	Sun Jun 29 11:51:49 2014
@@ -1,5 +1,5 @@
 /*
- * Copyright 2013 Garrett D'Amore <garrett@damore.org>
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -36,13 +36,11 @@
 int
 wctomb_l(char *s, wchar_t wchar, locale_t loc)
 {
-	static const mbstate_t initial = { 0 };
-	static mbstate_t mbs;
+	mbstate_t mbs = { 0 };
 	size_t rval;
 
 	if (s == NULL) {
 		/* No support for state dependent encodings. */
-		mbs = initial;
 		return (0);
 	}
 	if ((rval = wcrtomb_l(s, wchar, &mbs, loc)) == (size_t)-1)
--- old/usr/src/man/man3c/Makefile	Sun Jun 29 11:51:52 2014
+++ new/usr/src/man/man3c/Makefile	Sun Jun 29 11:51:52 2014
@@ -13,6 +13,7 @@
 # Copyright 2011, Richard Lowe
 # Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
 # Copyright 2013, OmniTI Computer Consulting, Inc. All rights reserved.
+# Copyright 2014 Garrett D'Amore <garrett@damore.org>
 #
 
 include		$(SRC)/Makefile.master
@@ -239,6 +240,7 @@
 	 	mutex_init.3c					\
 	 	nanosleep.3c					\
 	 	ndbm.3c						\
+	 	newlocale.3c					\
 	 	nl_langinfo.3c					\
 	 	offsetof.3c					\
 	 	opendir.3c					\
@@ -410,6 +412,7 @@
 	 	str2sig.3c					\
 	 	strcoll.3c					\
 	 	strerror.3c					\
+	 	strfmon.3c					\
 	 	strftime.3c					\
 	 	string.3c					\
 	 	string_to_decimal.3c				\
@@ -461,6 +464,8 @@
 	 	toascii.3c					\
 	 	tolower.3c					\
 	 	toupper.3c					\
+	 	towlower.3c					\
+	 	towupper.3c					\
 	 	truncate.3c					\
 	 	tsearch.3c					\
 	 	ttyname.3c					\
@@ -475,6 +480,7 @@
 	 	ungetwc.3c					\
 	 	unlockpt.3c					\
 	 	unsetenv.3c					\
+	 	uselocale.3c					\
 	 	usleep.3c					\
 	 	vfwprintf.3c					\
 	 	vlfmt.3c					\
@@ -499,6 +505,7 @@
 	 	wcsxfrm.3c					\
 	 	wctob.3c					\
 	 	wctomb.3c					\
+	 	wctrans.3c					\
 	 	wctype.3c					\
 	 	wcwidth.3c					\
 	 	wmemchr.3c					\
@@ -654,6 +661,7 @@
 	 	bcopy.3c				\
 	 	bind_textdomain_codeset.3c		\
 	 	bindtextdomain.3c			\
+	 	btowc_l.3c				\
 	 	bzero.3c				\
 	 	calloc.3c				\
 	 	catclose.3c				\
@@ -698,6 +706,7 @@
 	 	door_unbind.3c				\
 	 	double_to_decimal.3c			\
 		dup3.3c					\
+	 	duplocale.3c				\
 	 	edata.3c				\
 	 	endgrent.3c				\
 	 	endnetgrent.3c				\
@@ -725,6 +734,7 @@
 	 	fgets.3c				\
 	 	fgetspent.3c				\
 	 	fgetspent_r.3c				\
+	 	fgetwc_l.3c				\
 	 	fgetws.3c				\
 	 	file_to_decimal.3c			\
 	 	fileno.3c				\
@@ -738,6 +748,7 @@
 	 	fpsetsticky.3c				\
 	 	fputs.3c				\
 	 	free.3c					\
+	 	freelocale.3c				\
 	 	fscanf.3c				\
 	 	fseeko.3c				\
 	 	fsetattr.3c				\
@@ -784,6 +795,7 @@
 	 	getvfsfile.3c				\
 	 	getvfsspec.3c				\
 	 	getw.3c					\
+	 	getwc_l.3c				\
 	 	getzoneidbyname.3c			\
 	 	getzonenamebyid.3c			\
 	 	globfree.3c				\
@@ -796,36 +808,71 @@
 	 	initstate.3c				\
 	 	innetgr.3c				\
 	 	isalnum.3c				\
+	 	isalnum_l.3c				\
 	 	isalpha.3c				\
+	 	isalpha_l.3c				\
 	 	isascii.3c				\
 	 	isblank.3c				\
+	 	isblank_l.3c				\
 	 	iscntrl.3c				\
+	 	iscntrl_l.3c				\
 	 	isdigit.3c				\
+	 	isdigit_l.3c				\
 	 	isenglish.3c				\
 	 	isgraph.3c				\
+	 	isgraph_l.3c				\
 	 	isideogram.3c				\
 	 	islower.3c				\
+	 	islower_l.3c				\
 	 	isnanf.3c				\
 	 	isnumber.3c				\
 	 	isphonogram.3c				\
 	 	isprint.3c				\
+	 	isprint_l.3c				\
 	 	ispunct.3c				\
+	 	ispunct_l.3c				\
 	 	isspace.3c				\
+	 	isspace_l.3c				\
 	 	isspecial.3c				\
 	 	isupper.3c				\
+	 	isupper_l.3c				\
 	 	iswalnum.3c				\
+	 	iswalnum_l.3c				\
+	 	iswalpha_l.3c				\
 	 	iswascii.3c				\
 	 	iswblank.3c				\
+	 	iswblank_l.3c				\
 	 	iswcntrl.3c				\
+	 	iswcntrl_l.3c				\
+	 	iswctype_l.3c				\
 	 	iswdigit.3c				\
+	 	iswdigit_l.3c				\
 	 	iswgraph.3c				\
+	 	iswgraph_l.3c				\
+	 	iswideogram.3c				\
+	 	iswideogram_l.3c			\
+	 	iswhexnumber.3c				\
+	 	iswhexnumber_l.3c			\
 	 	iswlower.3c				\
+	 	iswlower_l.3c				\
+	 	iswnumber.3c				\
+	 	iswnumber_l.3c				\
+	 	iswphonogram.3c				\
+	 	iswphonogram_l.3c			\
 	 	iswprint.3c				\
+	 	iswprint_l.3c				\
 	 	iswpunct.3c				\
+	 	iswpunct_l.3c				\
 	 	iswspace.3c				\
+	 	iswspace_l.3c				\
+	 	iswspecial.3c				\
+	 	iswspecial_l.3c				\
 	 	iswupper.3c				\
+	 	iswupper_l.3c				\
 	 	iswxdigit.3c				\
+	 	iswxdigit_l.3c				\
 	 	isxdigit.3c				\
+	 	isxdigit_l.3c				\
 	 	jrand48.3c				\
 	 	l64a.3c					\
 	 	labs.3c					\
@@ -840,6 +887,16 @@
 	 	longjmp.3c				\
 	 	lrand48.3c				\
 	 	major.3c				\
+	 	mblen_l.3c				\
+	 	mbrlen_l.3c				\
+	 	mbrtowc_l.3c				\
+	 	mbsinit_l.3c				\
+	 	mbsnrtowcs.3c				\
+	 	mbsnrtowcs_l.3c				\
+	 	mbsrtowcs_l.3c				\
+	 	mbstowcs.3c				\
+	 	mbstowcs_l.3c				\
+	 	mbtowc_l.3c				\
 	 	memalign.3c				\
 	 	membar_consumer.3c			\
 	 	membar_enter.3c				\
@@ -868,6 +925,7 @@
 	 	mutex_lock.3c				\
 	 	mutex_trylock.3c			\
 	 	mutex_unlock.3c				\
+	 	nl_langinfo_l.3c			\
 	 	nftw.3c					\
 	 	ngettext.3c				\
 	 	nrand48.3c				\
@@ -1057,22 +1115,28 @@
 		stdin.3c				\
 		stdout.3c				\
 	 	strcasecmp.3c				\
+	 	strcasecmp_l.3c				\
 	 	strcat.3c				\
 	 	strchr.3c				\
 	 	strcmp.3c				\
+	 	strcoll_l.3c				\
 	 	strcpy.3c				\
 	 	strcspn.3c				\
 	 	strdup.3c				\
 	 	strerror_r.3c				\
+	 	strfmon_l.3c				\
+	 	strftime_l.3c				\
 	 	strlcat.3c				\
 	 	strlcpy.3c				\
 	 	strlen.3c				\
 	 	strncasecmp.3c				\
+	 	strncasecmp_l.3c			\
 	 	strncat.3c				\
 	 	strncmp.3c				\
 	 	strncpy.3c				\
 	 	strnlen.3c				\
 	 	strpbrk.3c				\
+	 	strptime_l.3c				\
 	 	strrchr.3c				\
 	 	strsep.3c				\
 	 	strspn.3c				\
@@ -1084,6 +1148,7 @@
 	 	strtoll.3c				\
 	 	strtoull.3c				\
 	 	strtoumax.3c				\
+	 	strxfrm_l.3c				\
 	 	swapcontext.3c				\
 	 	swprintf.3c				\
 	 	swscanf.3c				\
@@ -1104,6 +1169,12 @@
 	 	timerisset.3c				\
 	 	timersub.3c				\
 	 	tmpnam_r.3c				\
+	 	tolower_l.3c				\
+	 	toupper_l.3c				\
+	 	towctrans.3c				\
+	 	towctrans_l.3c				\
+	 	towlower_l.3c				\
+	 	towupper_l.3c				\
 	 	ttyname_r.3c				\
 	 	twalk.3c				\
 	 	tzset.3c				\
@@ -1158,9 +1229,11 @@
 	 	watoi.3c				\
 	 	watol.3c				\
 	 	watoll.3c				\
+	 	wcrtomb_l.3c				\
 	 	wcscat.3c				\
 	 	wcschr.3c				\
 	 	wcscmp.3c				\
+	 	wcscoll_l.3c				\
 	 	wcscpy.3c				\
 	 	wcscspn.3c				\
 	 	wcsetno.3c				\
@@ -1178,6 +1251,12 @@
 	 	wcstoull.3c				\
 	 	wcstoumax.3c				\
 	 	wcswcs.3c				\
+	 	wcswidth_l.3c				\
+	 	wctob_l.3c				\
+	 	wctomb_l.3c				\
+	 	wctrans_l.3c				\
+	 	wctype_l.3c				\
+	 	wcwidth_l.3c				\
 	 	windex.3c				\
 	 	wordfree.3c				\
 	 	wprintf.3c				\
@@ -1342,6 +1421,8 @@
 bcopy.3c				:= LINKSRC = bstring.3c
 bzero.3c				:= LINKSRC = bstring.3c
 
+btowc_l.3c				:= LINKSRC = btowc.3c
+
 catclose.3c				:= LINKSRC = catopen.3c
 
 cfgetospeed.3c				:= LINKSRC = cfgetispeed.3c
@@ -1377,18 +1458,30 @@
 tzset.3c				:= LINKSRC = ctime.3c
 
 isalnum.3c				:= LINKSRC = ctype.3c
+isalnum_l.3c				:= LINKSRC = ctype.3c
 isalpha.3c				:= LINKSRC = ctype.3c
+isalpha_l.3c				:= LINKSRC = ctype.3c
 isascii.3c				:= LINKSRC = ctype.3c
 isblank.3c				:= LINKSRC = ctype.3c
+isblank_l.3c				:= LINKSRC = ctype.3c
 iscntrl.3c				:= LINKSRC = ctype.3c
+iscntrl_l.3c				:= LINKSRC = ctype.3c
 isdigit.3c				:= LINKSRC = ctype.3c
+isdigit_l.3c				:= LINKSRC = ctype.3c
 isgraph.3c				:= LINKSRC = ctype.3c
+isgraph_l.3c				:= LINKSRC = ctype.3c
 islower.3c				:= LINKSRC = ctype.3c
+islower_l.3c				:= LINKSRC = ctype.3c
 isprint.3c				:= LINKSRC = ctype.3c
+isprint_l.3c				:= LINKSRC = ctype.3c
 ispunct.3c				:= LINKSRC = ctype.3c
+ispunct_l.3c				:= LINKSRC = ctype.3c
 isspace.3c				:= LINKSRC = ctype.3c
+isspace_l.3c				:= LINKSRC = ctype.3c
 isupper.3c				:= LINKSRC = ctype.3c
+isupper_l.3c				:= LINKSRC = ctype.3c
 isxdigit.3c				:= LINKSRC = ctype.3c
+isxdigit_l.3c				:= LINKSRC = ctype.3c
 
 decimal_to_double.3c			:= LINKSRC = decimal_to_floating.3c
 decimal_to_extended.3c			:= LINKSRC = decimal_to_floating.3c
@@ -1462,6 +1555,8 @@
 getchar_unlocked.3c			:= LINKSRC = fgetc.3c
 getw.3c					:= LINKSRC = fgetc.3c
 
+fgetwc_l.3c				:= LINKSRC = fgetwc.3c
+
 double_to_decimal.3c			:= LINKSRC = floating_to_decimal.3c
 extended_to_decimal.3c			:= LINKSRC = floating_to_decimal.3c
 quadruple_to_decimal.3c			:= LINKSRC = floating_to_decimal.3c
@@ -1591,6 +1686,8 @@
 getvfsfile.3c				:= LINKSRC = getvfsent.3c
 getvfsspec.3c				:= LINKSRC = getvfsent.3c
 
+getwc_l.3c				:= LINKSRC = getwc.3c
+
 fgetws.3c				:= LINKSRC = getws.3c
 
 getzoneidbyname.3c			:= LINKSRC = getzoneid.3c
@@ -1616,18 +1713,42 @@
 isphonogram.3c				:= LINKSRC = iswalpha.3c
 isspecial.3c				:= LINKSRC = iswalpha.3c
 iswalnum.3c				:= LINKSRC = iswalpha.3c
+iswalnum_l.3c				:= LINKSRC = iswalpha.3c
+iswalpha_l.3c				:= LINKSRC = iswalpha.3c
 iswascii.3c				:= LINKSRC = iswalpha.3c
 iswblank.3c				:= LINKSRC = iswalpha.3c
+iswblank_l.3c				:= LINKSRC = iswalpha.3c
 iswcntrl.3c				:= LINKSRC = iswalpha.3c
+iswcntrl_l.3c				:= LINKSRC = iswalpha.3c
 iswdigit.3c				:= LINKSRC = iswalpha.3c
+iswdigit_l.3c				:= LINKSRC = iswalpha.3c
 iswgraph.3c				:= LINKSRC = iswalpha.3c
+iswgraph_l.3c				:= LINKSRC = iswalpha.3c
+iswhexnumber.3c				:= LINKSRC = iswalpha.3c
+iswhexnumber_l.3c			:= LINKSRC = iswalpha.3c
+iswideogram.3c				:= LINKSRC = iswalpha.3c
+iswideogram_l.3c			:= LINKSRC = iswalpha.3c
 iswlower.3c				:= LINKSRC = iswalpha.3c
+iswlower_l.3c				:= LINKSRC = iswalpha.3c
+iswnumber.3c				:= LINKSRC = iswalpha.3c
+iswnumber_l.3c				:= LINKSRC = iswalpha.3c
+iswphonogram.3c				:= LINKSRC = iswalpha.3c
+iswphonogram_l.3c			:= LINKSRC = iswalpha.3c
 iswprint.3c				:= LINKSRC = iswalpha.3c
+iswprint_l.3c				:= LINKSRC = iswalpha.3c
 iswpunct.3c				:= LINKSRC = iswalpha.3c
+iswpunct_l.3c				:= LINKSRC = iswalpha.3c
 iswspace.3c				:= LINKSRC = iswalpha.3c
+iswspace_l.3c				:= LINKSRC = iswalpha.3c
+iswspecial.3c				:= LINKSRC = iswalpha.3c
+iswspecial_l.3c				:= LINKSRC = iswalpha.3c
 iswupper.3c				:= LINKSRC = iswalpha.3c
+iswupper_l.3c				:= LINKSRC = iswalpha.3c
 iswxdigit.3c				:= LINKSRC = iswalpha.3c
+iswxdigit_l.3c				:= LINKSRC = iswalpha.3c
 
+iswctype_l.3c				:= LINKSRC = iswctype.3c
+
 ulckpwdf.3c				:= LINKSRC = lckpwdf.3c
 
 lfind.3c				:= LINKSRC = lsearch.3c
@@ -1644,6 +1765,22 @@
 realloc.3c				:= LINKSRC = malloc.3c
 valloc.3c				:= LINKSRC = malloc.3c
 
+mblen_l.3c				:= LINKSRC = mblen.3c
+
+mbrlen_l.3c				:= LINKSRC = mbrlen.3c
+
+mbrtowc_l.3c				:= LINKSRC = mbrtowc.3c
+
+mbsinit_l.3c				:= LINKSRC = mbsinit.3c
+
+mbsnrtowcs.3c				:= LINKSRC = mbsrtowcs.3c
+mbsnrtowcs_l.3c				:= LINKSRC = mbsrtowcs.3c
+mbsrtowcs_l.3c				:= LINKSRC = mbsrtowcs.3c
+mbstowcs.3c				:= LINKSRC = mbsrtowcs.3c
+mbstowcs_l.3c				:= LINKSRC = mbsrtowcs.3c
+
+mbtowc_l.3c				:= LINKSRC = mbtowc.3c
+
 membar_consumer.3c			:= LINKSRC = membar_ops.3c
 membar_enter.3c				:= LINKSRC = membar_ops.3c
 membar_exit.3c				:= LINKSRC = membar_ops.3c
@@ -1687,6 +1824,11 @@
 dbm_open.3c				:= LINKSRC = ndbm.3c
 dbm_store.3c				:= LINKSRC = ndbm.3c
 
+duplocale.3c				:= LINKSRC = newlocale.3c
+freelocale.3c				:= LINKSRC = newlocale.3c
+
+nl_langinfo_l.3c			:= LINKSRC = nl_langinfo.3c
+
 fdopendir.3c				:= LINKSRC = opendir.3c
 
 errno.3c				:= LINKSRC = perror.3c
@@ -1938,12 +2080,18 @@
 
 sig2str.3c				:= LINKSRC = str2sig.3c
 
+strcoll_l.3c				:= LINKSRC = strcoll.3c
+
 strerror_r.3c				:= LINKSRC = strerror.3c
 
+strfmon_l.3c				:= LINKSRC = strfmon.3c
+
 ascftime.3c				:= LINKSRC = strftime.3c
 cftime.3c				:= LINKSRC = strftime.3c
+strftime_l.3c				:= LINKSRC = strftime.3c
 
 strcasecmp.3c				:= LINKSRC = string.3c
+strcasecmp_l.3c				:= LINKSRC = string.3c
 strcat.3c				:= LINKSRC = string.3c
 strchr.3c				:= LINKSRC = string.3c
 strcmp.3c				:= LINKSRC = string.3c
@@ -1954,6 +2102,7 @@
 strlcpy.3c				:= LINKSRC = string.3c
 strlen.3c				:= LINKSRC = string.3c
 strncasecmp.3c				:= LINKSRC = string.3c
+strncasecmp_l.3c			:= LINKSRC = string.3c
 strncat.3c				:= LINKSRC = string.3c
 strncmp.3c				:= LINKSRC = string.3c
 strncpy.3c				:= LINKSRC = string.3c
@@ -1969,6 +2118,8 @@
 file_to_decimal.3c			:= LINKSRC = string_to_decimal.3c
 func_to_decimal.3c			:= LINKSRC = string_to_decimal.3c
 
+strptime_l.3c				:= LINKSRC = strptime.3c
+
 atof.3c					:= LINKSRC = strtod.3c
 strtof.3c				:= LINKSRC = strtod.3c
 strtold.3c				:= LINKSRC = strtod.3c
@@ -1983,8 +2134,11 @@
 ulltostr.3c				:= LINKSRC = strtol.3c
 
 strtoull.3c				:= LINKSRC = strtoul.3c
+
 wstostr.3c				:= LINKSRC = strtows.3c
 
+strxfrm_l.3c				:= LINKSRC = strxfrm.3c
+
 closelog.3c				:= LINKSRC = syslog.3c
 openlog.3c				:= LINKSRC = syslog.3c
 setlogmask.3c				:= LINKSRC = syslog.3c
@@ -2010,6 +2164,14 @@
 tempnam.3c				:= LINKSRC = tmpnam.3c
 tmpnam_r.3c				:= LINKSRC = tmpnam.3c
 
+tolower_l.3c				:= LINKSRC = tolower.3c
+
+toupper_l.3c				:= LINKSRC = toupper.3c
+
+towlower_l.3c				:= LINKSRC = towlower.3c
+
+towupper_l.3c				:= LINKSRC = towupper.3c
+
 ftruncate.3c				:= LINKSRC = truncate.3c
 
 tdelete.3c				:= LINKSRC = tsearch.3c
@@ -2056,6 +2218,9 @@
 backtrace_symbols_fd.3c			:= LINKSRC = walkcontext.3c
 printstack.3c				:= LINKSRC = walkcontext.3c
 
+wcrtomb_l.3c				:= LINKSRC = wcrtomb.3c
+
+wcscoll_l.3c				:= LINKSRC = wcscoll.3c
 wscoll.3c				:= LINKSRC = wcscoll.3c
 
 watof.3c				:= LINKSRC = wcstod.3c
@@ -2102,16 +2267,29 @@
 wsrchr.3c				:= LINKSRC = wcstring.3c
 wsspn.3c				:= LINKSRC = wcstring.3c
 wstok.3c				:= LINKSRC = wcstring.3c
-
-wsxfrm.3c				:= LINKSRC = wcsxfrm.3c
-
-wordfree.3c				:= LINKSRC = wordexp.3c
-
 wscasecmp.3c				:= LINKSRC = wstring.3c
 wscol.3c				:= LINKSRC = wstring.3c
 wsdup.3c				:= LINKSRC = wstring.3c
 wsncasecmp.3c				:= LINKSRC = wstring.3c
 
+wcswidth_l.3c				:= LINKSRC = wcswidth.3c
+
+wsxfrm.3c				:= LINKSRC = wcsxfrm.3c
+
+wctob_l.3c				:= LINKSRC = wctob.3c
+
+wctomb_l.3c				:= LINKSRC = wctomb.3c
+
+towctrans.3c				:= LINKSRC = wctrans.3c
+towctrans_l.3c				:= LINKSRC = wctrans.3c
+wctrans_l.3c				:= LINKSRC = wctrans.3c
+
+wctype_l.3c				:= LINKSRC = wctype.3c
+
+wcwidth_l.3c				:= LINKSRC = wcwidth.3c
+
+wordfree.3c				:= LINKSRC = wordexp.3c
+
 .KEEP_STATE:
 
 include		$(SRC)/man/Makefile.man
